#include "Note.h"
#include <sstream>
#include <math.h>
#include <libintl.h>
#define _(String) gettext (String)

const double CNote::m_fNoteStandard[18]=
{
	//The notes frequencies
	32.703203125,	//C0 etc...
	34.6472125,
	34.6472125,
	36.708125,
	38.890859375,
	38.890859375,
	41.2034375,
	43.653515625,
	46.249296875,
	46.249296875,
	48.9994523125,
	51.913125,
	51.913125,
	55,
	58.27046875,
	58.27046875,
	61.735390625,
	61.735390625
};

//default constructor
CNote::CNote()
{
	Initialisation();	//variable initialisation
	m_bvalid=false;  //validity equal false
}

//constructor with the name of the note
CNote::CNote(std::string NoteName)
{
     m_szNoteName=NoteName; //set the name of the note
     Initialisation(); //variable initialisation
     CalculateNote(); //Calculate the frequency of the note
}

//destructor
CNote::~CNote()
{
}

void CNote::Initialisation()
{
     m_FreqNote=0; //the frequency by default is equal to zero
}

std::string CNote::GetNoteName(void)
{
     return m_szNoteName; //return the Note Name value
}

void CNote::SetNoteName(std::string NoteName)
{
     m_szNoteName=NoteName; //set the note name
     CalculateNote();  //Calculate the frequency of the note
}
double CNote::GetFrequency(void)
{
     return m_FreqNote; //return the frequency of the note
}

void CNote::CalculateNote(void)
{
     int Harmonic, comparison=1;
     int j=0;
     std::string Note, Level;
     //For all the char of the note
     for (int i=0;i<m_szNoteName.size();i++)
     {
	  std::string Temp;
	  int number;
	  Temp=m_szNoteName.at(i);
	  std::istringstream numeric(Temp);
	  numeric>>number;
	  
	  //if the char is numeric then save
	  if (!numeric.fail())
	       Level+=Temp;
     }
     
     //Transform the number string in a int
     std::istringstream iss(Level);
     iss>>Harmonic;
     //Get the letter of the note (A, B ...Etc)
     Note.append(m_szNoteName,0,m_szNoteName.size()-Level.size());
     //Search the index of the note
     while((comparison!=0) && (j<18))
     {
	  comparison=Name_Note[j].compare(Note);
	  j++;
     }
     //If note found then the validity=false
     if (comparison!=0)
     {
	  m_bvalid=false;
     }
     else  //else the validity=true and the frequency of the note is calculated
     {
	  m_FreqNote=(double)m_fNoteStandard[j-1]*pow(2,Harmonic);
	  m_bvalid=true;
     }
}

bool CNote::GetValidity(void)
{
     return m_bvalid; //return the validty of the note
}

void CNote::SetFrequency(double Frequency)
{
     m_FreqNote=Frequency; //set the frequency of the note
     m_bvalid=true; //the note is valid
}
