// Note.h : interface for the CNote class
// CNote represent a Note with :
// - his name (E1 .....)
// - his frequency 
// - his validity
/////////////////////////////////////////////////////////////////
#ifndef CNOTE_H_INCLUDED
#define CNOTE_H_INCLUDED
#include <iostream>
#include <vector>
#include "Variables.h"
//Class CNote

class CNote
{
public:
     CNote();
     ~CNote();
     CNote(std::string NoteName);  //create the class with the note name
     std::string GetNoteName(void); //return the note's name
     void SetNoteName(std::string NoteName); //set the name of the note
     double GetFrequency(void);  //return the frequency of the note
     void SetFrequency(double Frequency); //set the frequency of the note
     bool GetValidity(void); //return the validity of the note
private:
     static const double m_fNoteStandard[18];	//The frequencies of the scale
     std::string m_szNoteName;  //the name of the note
     double m_FreqNote; //the frequency of the note
     bool m_bvalid;  //the validity of the note
     void Initialisation();	//variable initialisation
     void CalculateNote(void); //Calculate the frequency of the note
};
#endif
